package com.fp.persistence.pbpm.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TBPMGROUPS*/
@Entity(name="TbpmGroups")
@Table(name="TBPMGROUPS")
public class TbpmGroups extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TbpmGroups
*/
@EmbeddedId
private TbpmGroupsKey pk;
@Column(name="DESCRIPTION", nullable=true)

/**
* Detalle del grupo de usuario de bpm
*/
private String description;

@Column(name="EMAIL", nullable=true)

/**
* Campo para el ingreso de email
*/
private String email;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistick locking del registro
*/
private Integer recordversion;

/**Contructor por defecto*/
public TbpmGroups(){
}
/**Contructor de TbpmGroups
@param pPk Clave Primaria del entity
*/
public TbpmGroups(TbpmGroupsKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TbpmGroups
*/
public static TbpmGroups find(EntityManager pEntityManager,TbpmGroupsKey pKey) throws Exception{
    TbpmGroups obj = pEntityManager.find(TbpmGroups.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TbpmGroups
@return El objeto que referencia a la Clave primaria de TbpmGroups
*/
public TbpmGroupsKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TbpmGroups
@param pPk El objeto que referencia a la nueva Clave primaria de TbpmGroups
*/
public void setPk(TbpmGroupsKey pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de email
@return valor de email*/
public String getEmail(){
  return email;
}
/**Fija el valor de email
@param pEmail nuevo Valor de email*/
public void setEmail(String pEmail){
  email=pEmail;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TbpmGroups))return false;
    TbpmGroups that = (TbpmGroups) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TbpmGroups
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TbpmGroups
*/
public Object createInstance(){
 TbpmGroups instance=new TbpmGroups();	
 instance.setPk(new TbpmGroupsKey());
 return instance;
}
/**Clona la entidad TbpmGroups
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TbpmGroups p=(TbpmGroups)this.clone();
  p.setPk((TbpmGroupsKey)this.pk.cloneMe());
  return p;
}
}
